<?php
/**
 * MyBB 1.6
 * Copyright 123 Flash Chat
 *
 * Website: http://www.123flashchat.com
 * License: http://mybb.com/about/license
 * 
 * author:cheney
 *
 * $Id: chat.php 2014-04-29  Cheney $
 */
 
// Disallow direct access to this file for security reasons
if(!defined("IN_MYBB")){
	die("Direct initialization of this file is not allowed.<br /><br />Please make sure IN_MYBB is defined.");
}
define('CACHE_PATH', dirname(dirname(dirname(__FILE__))). '/cache/');


$plugins->add_hook("pre_output_page", "chat_status");

$plugins->add_hook("admin_forum_menu", "chat_admin_nav");
$plugins->add_hook("admin_forum_permissions", "chat_admin_permissions");
$plugins->add_hook("admin_load", "chat_admin");
$plugins->add_hook("admin_forum_action_handler", "chat_action_handler");

if(!empty($_GET['mod']) && $_GET['mod'] = '123flashchat'){
	$act = !empty($_GET['act']) ? $_GET['act'] : 'chat';
	if($act == 'loginchat'){		
		$LOGIN_SUCCESS = 0;
		$LOGIN_PASSWD_ERROR = 1;
		$LOGIN_NICK_EXIST = 2;
		$LOGIN_ERROR = 3;
		$LOGIN_ERROR_NOUSERID = 4;
		$LOGIN_SUCCESS_ADMIN = 5;
		$LOGIN_NOT_ALLOW_GUEST = 6;
		$LOGIN_USER_BANED = 7;
		$username = isset($_GET['username']) ? trim(htmlspecialchars($_GET['username'])) : '';
		$username = substr(str_replace("\\'", "'", $username), 0, 25);
		$username = str_replace("'", "\\'", $username);		
		$password = isset($_GET['password']) ? $_GET['password'] : '';		
		if($username && $password){
			$chatUserInfo = chat_getUserInfoByName($username);
			if($chatUserInfo){
				require_once(dirname(dirname(__FILE__)) . "/functions_user.php");
				$encrypted_password = salt_password(md5($password), $chatUserInfo['salt']);
				if($password == $chatUserInfo['password'] || $encrypted_password == $chatUserInfo['password']){
					if($chatUserInfo['usergroup'] == 4 || $chatUserInfo['usergroup'] == 3){
						echo $LOGIN_SUCCESS_ADMIN;
					}else{
						echo $LOGIN_SUCCESS;
					}
					echo '|eml=' . $chatUserInfo['email'];					
				}else{
					echo $LOGIN_PASSWD_ERROR;
				}				
			}else{
				echo $LOGIN_ERROR_NOUSERID;
			}
		}else{
			echo $LOGIN_ERROR;
		}
		exit;
	}else if($act == 'chat'){
		$plugins->add_hook("pre_output_page", "chat_chatpage");
		
	}
}


function chat_info(){
	/**
	 * Array of information about the plugin.
	 * name: The name of the plugin
	 * description: Description of what the plugin does
	 * website: The website the plugin is maintained at (Optional)
	 * author: The name of the author of the plugin
	 * authorsite: The URL to the website of the author (Optional)
	 * version: The version number of the plugin
	 * guid: Unique ID issued by the MyBB Mods site for version checking
	 * compatibility: A CSV list of MyBB versions supported. Ex, "121,123", "12*". Wildcards supported.
	 */
	return array(
		"name"			=> "123 Flash Chat",
		"description"	=> "123 Flash Chat for MyBB!",
		"website"		=> "http://www.123flashchat.com",
		"author"		=> "support@123flashchat.com",
		"authorsite"	=> "http://www.123flashchat.com",
		"version"		=> "3.0",
		"guid" 			=> "",
		"compatibility" => "*"
	);
}

function chat_install(){
	global $db, $mybb, $lang;
	$db->write_query("CREATE TABLE ".TABLE_PREFIX."123flashchat (
		id						TINYINT(1)			NOT NULL auto_increment,
      	fc_extendserver			TINYINT(1)			NOT NULL default '2',
      	fc_servertype			TINYINT(1)			NOT NULL default '0',
      	fc_server_host			VARCHAR(255)		NOT NULL default '',
		fc_server_port			INT(5)				NOT NULL default 0,
      	fc_server_host_s		VARCHAR(255)		NOT NULL default '',
		fc_server_port_s		INT(5)				NOT NULL default 0,
      	fc_server_host_h		VARCHAR(255)		NOT NULL default '',
		fc_server_port_h		INT(5)				NOT NULL default 0,
		fc_client_loc			VARCHAR(255)		NOT NULL default '',
		fc_api_url				VARCHAR(255)		NOT NULL default '',
		fc_group				VARCHAR(255)		default '',
		fc_room					VARCHAR(255)		NOT NULL default 'Lobby',
		fc_room_list			TINYINT(1)			NOT NULL default '1',
		fc_user_list			TINYINT(1)			NOT NULL default '1',
		fc_clienttype			TINYINT(1)			NOT NULL default '0',
		fc_fullscreen			TINYINT(1)			NOT NULL default '1',
		fc_client_width			INT(5)				NOT NULL default '750',
		fc_client_height		INT(5)				NOT NULL default '528',
		fc_client_lang			VARCHAR(20)			NOT NULL default 'auto',
		fc_client_skin			VARCHAR(20)			NOT NULL default 'default',
		PRIMARY KEY (id)
	)");
	
	$chatdata = array(
		'fc_extendserver' => 2,
	);
	$db->insert_query("123flashchat", $chatdata);
}

function chat_is_installed(){
	global $db;
	if($db->table_exists("123flashchat"))
  	{
  		return true;
	}
	return false;
}

function chat_uninstall(){
	global $db;	
	if($db->table_exists("123flashchat"))
	{
		$db->drop_table('123flashchat');
	}
	
}

function chat_action_handler(&$action){
	$action['chat'] = array('active' => 'chat', 'file' => 'chat.php');
}

function chat_admin_nav(&$sub_menu){
	global $mybb, $lang;
	end($sub_menu);
	$key = (key($sub_menu))+10;
	if(!$key){
		$key = '80';
	}
	$sub_menu[$key] = array('id' => 'chat', 'title' => 'Chat Settings', 'link' => "index.php?module=forum-chat");
}

function chat_admin_permissions(&$admin_permissions){
	global $db, $mybb;
	$admin_permissions['chat'] =  "Can Manage 123 Flash Chat?";
}

function chat_admin(){
	global $mybb, $db, $page, $lang;
	if($page->active_action != "chat"){
		return;
	}
	if(!$mybb->input['action']){
		require MYBB_ROOT."inc/class_parser.php";
		$parser = new postParser;
		$type = !empty($_GET['type'])? $_GET['type'] : 'settings';
		$tabs = array(
			'settings' => array(
				'link' => 'index.php?module=forum-chat',
				'title' => 'Settings'
			),
			'adminpanel' => array(
				'link' => 'index.php?module=forum-chat&type=adminpanel',
				'title' => 'Admin Panel'
			)
		);
		$page->add_breadcrumb_item("123 Flash Chat");
		$page->output_header("123 Flash Chat");			
		$chatSettings = chat_getChatSetting();
				
		if($type == 'adminpanel'){	//chat adminpanel
			$page->output_nav_tabs($tabs, 'adminpanel');
			
			if($chatSettings['fc_extendserver'] == 2){
?>
<p style="margin-top:30px; text-align:center;">Sorry! Admin Panel is not available in the Free Chat Hosting Edition. 123FlashChat Full Version starts at $20. <br>Click the link below to have a live Admin Panel Demo for testing.</p>
<p style="text-align:center;"><a href="http://www.123flashchat.com/admin-panel-free.html" target="_blank">Live Demo</a></p>
<?php 
			}else{
				$chatUrl = chat_getChatUrl($chatSettings, TRUE);
?>
<div style="margin-top:30px;">
	<script src="<?php echo $chatSettings['fc_client_loc']; ?>123flashchat.js"></script>
	<object classid="clsid:D27CDB6E-AE6D-11cf-96B8-444553540000" codebase="http://download.macromedia.com/pub/shockwave/cabs/flash/swflash.cab#version=6,0,19,0" width="100%" height="600"  id="topcmm_123flashchat" type="application/x-shockwave-flash">
	    <param name=movie value="<?php echo $chatUrl; ?>">
	    <param name=quality value="high">
	    <param name="menu" value="false">
	    <param name="allowScriptAccess" value="always">
	    <embed src="<?php echo $chatUrl; ?>" quality="high" menu="false" width="100%" height="600" allowScriptAccess="always" type="application/x-shockwave-flash" pluginspace="http://www.macromedia.com/go/getflashplayer"   name="topcmm_123flashchat"></embed>
	</object>
</div>
<?php 			
			}			
		}else{	//chat settings
			if(!empty($_POST)){
				$extendserver = isset($_POST['extendserver']) ? $_POST['extendserver'] : '2';
				$data->extendserver = $extendserver;
				$data->servertype = isset($_POST['servertype']) ? $_POST['servertype'] : '0';
				switch ($extendserver){
					case '0':
						$data->client_loc = !empty($_POST['client_loc']) ? $_POST['client_loc'] . (substr($_POST['client_loc'],-1,1) != '/' ? '/' : '') : '';
						if($data->client_loc){
		            		$serverinfo = chat_getServerHostPortLocal($data->client_loc);
		            		$data->server_host = !empty($_POST['server_host']) ? $_POST['server_host'] : (empty($serverinfo['fc_server_host']) ? $_SERVER['HTTP_HOST'] : $serverinfo['fc_server_host']) ;
		            		$data->server_host_s = empty($serverinfo['fc_server_host_s']) ? $data->server_host : $serverinfo['fc_server_host_s'];
		            		$data->server_host_h = empty($serverinfo['fc_server_host_h']) ? $data->server_host : $serverinfo['fc_server_host_h'];
		            		if(!is_numeric($_POST['server_port']) || strpos($_POST['server_port'] ,".")!==false){
		            			$data->server_port = empty($serverinfo['fc_server_port']) ? ( $data->servertype == 1 ? '51212' : '51127') : $serverinfo['fc_server_port'] ;
		            		}else{
		            			$data->server_port = $_POST['server_port'];
		            		}
		            		if(!is_numeric($_POST['server_port_h']) || strpos($_POST['server_port_h'] ,".")!==false){
		            			$data->server_port_h = empty($serverinfo['fc_server_port_h']) ? ( $data->servertype == 1 ? '31212' : '35555') : $serverinfo['fc_server_port_h'] ;
		            		}else{
		            			$data->server_port_h = $_POST['server_port_h'];
		            		}
		            		$data->server_port_s = empty($serverinfo['fc_server_port_s']) ? ( $data->servertype == 1 ? '51213' : '51128') : $serverinfo['fc_server_port_s'] ;
		            		$data->api_url = 'http://' . $data->server_host . ':' . $data->server_port_h . '/';
		            	}else{
		            		$data->server_host = $_SERVER['HTTP_HOST'];
		            		$data->server_host_h = $data->server_host_s = $data->server_host;
		            		if($data->servertype == 1){
		            			$data->server_port_h = '31212';
		            			$data->server_port_s = '51213';
		            			$data->server_port = '51212';
		            		}else{
		            			$data->server_port_h = '35555';
		            			$data->server_port_s = '51128';
		            			$data->server_port = '51127';
		            		}
		            		$data->api_url = 'http://' . $data->server_host . ':' . $data->server_port_h . '/';
		            		$data->client_loc = $data->api_url;
		            	}
		            	$s_own_loc = 1;
			            $c_own_loc = 1;
			            $da = 1;
			            if($_POST['server_loc']){
			            	$c_own_loc = validate_client($data->client_loc);
		            		$da = validate_data_api($data->api_url . 'online.js');
				            if($c_own_loc || $da){
				            	flash_message('Chat Server http_port or Client location is configured incorrectly!', 'error');
								admin_redirect("index.php?module=forum-chat");
			            	}
			            }else{
			            	$c_own_loc = validate_client($data->client_loc);
			            	if($c_own_loc){
			            		flash_message('Chat Server http_port or Client location is configured incorrectly!', 'error');
								admin_redirect("index.php?module=forum-chat");
			            	}
			            }
		            	$check = validate_client('http://'.parse_url($data->client_loc, PHP_URL_HOST).':'.$data->server_port_h.'/');
		            	if($check){
		            		flash_message('Client Location is configured incorrectly!', 'error');
							admin_redirect("index.php?module=forum-chat");
		            	}						
						break;
					case '1':
						$data->client_loc = !empty($_POST['client_loc']) ? $_POST['client_loc'] . (substr($_POST['client_loc'],-1,1) != '/' ? '/' : '') : '';
						if($data->client_loc == ""){
							flash_message('Client Location is Empty!', 'error');
							admin_redirect("index.php?module=forum-chat");
						}
						$serverinfo = chat_getServerHostPortHost($data->client_loc);
						if($serverinfo){					
							$data->server_host = empty($serverinfo['fc_server_host']) ? parse_url($data->client_loc, PHP_URL_HOST) : $serverinfo['fc_server_host'];
							$data->server_host_s = empty($serverinfo['fc_server_host_s']) ? '' : $serverinfo['fc_server_host_s'];
							$data->server_host_h = empty($serverinfo['fc_server_host_h']) ? '' : $serverinfo['fc_server_host_h'];
							$data->server_port = empty($serverinfo['fc_server_port']) ? '' : $serverinfo['fc_server_port'];
							$data->server_port_h = empty($serverinfo['fc_server_port_h']) ? '' : $serverinfo['fc_server_port_h'];
		            		$data->server_port_s = empty($serverinfo['fc_server_port_s']) ? '' : $serverinfo['fc_server_port_s'];
		            		$data->api_url = 'http://' . $data->server_host . '/';
		            		$data->group = substr(parse_url($data->client_loc, PHP_URL_PATH),1,-1);
							$c_own_loc = validate_client($data->client_loc);
							$da = validate_data_api($data->api_url . 'online.js?group=' . $data->group);
					        if($c_own_loc || $da){
								flash_message('Client Location is configured incorrectly!', 'error');
								admin_redirect("index.php?module=forum-chat");
					        }
						}else{
							flash_message('Client Location is configured incorrectly!', 'error');
							admin_redirect("index.php?module=forum-chat");
						}
						break;
					case '2':
					default:
						$room = $_POST['room'];
						if(trim($room) != ''){
							preg_match("/\w+$/", $room,$matches);
							if(strlen($room) != strlen($matches[0])){
								//OW::getFeedback()->error(OW::getLanguage()->text('123flashchat', 'chat_name_error'));
								flash_message('Room Name can only use numbers,letters and underline!', 'error');
								admin_redirect("index.php?module=forum-chat");
							}
							$data->room = $room;
						}else{
							$data->room = 'Lobby';
						}
						break;						
				}
				
				if($data->servertype == 1){
					$data->clienttype = 0;
				}else{
					$data->clienttype = isset($_POST['clienttype']) ? $_POST['clienttype'] : 0;
				}
				$data->fullscreen = isset($_POST['fullscreen']) ? $_POST['fullscreen'] : 1;
				$data->room_list = isset($_POST['room_list']) ? $_POST['room_list'] : 1;
				$data->user_list = isset($_POST['user_list']) ? $_POST['user_list'] : 1;
				$data->client_width = (is_numeric($_POST['client_width']) && $_POST['client_width'] >= 700) ? $_POST['client_width'] : 700;
				$data->client_height = (is_numeric($_POST['client_height']) && $_POST['client_height'] >= 642) ? $_POST['client_height'] : 642;
				$data->client_lang = isset($_POST['client_lang']) ? $_POST['client_lang'] : "auto";
				$data->client_skin = isset($_POST['client_skin']) ? $_POST['client_skin'] : "default";
				
				chat_saveConfig($data);
				
			}
			$valid = chat_getValid($chatSettings);
?>
<style>
<!--
.hidden{display:none;}
label{margin-right:15px;}
-->
</style>
<script type="text/javascript">
function dE(id, s){
	var e = document.getElementById(id);
	//e.style.display = (s == 1) ? '' : 'none';
	e.className = (s == 1) ? '' : 'hidden';
	e.class = (s == 1) ? '' : 'hidden';
}

function showchatsize(s){
	dE('chatsize',s);
}
      
function setclienttype(){
    if(document.getElementById("servertype1").checked){
        dE('client_type',0);
    }else if(document.getElementById("servertype0").checked){
        dE('client_type',1);
    }
}
      
function chooseservertype(s){
	dE('chat_port',1);
	dE('chat_host',1);
	dE('http_port',1);
    if(s == 1){
        document.getElementById("default_server_port").innerHTML = '51212';
        document.getElementById("default_http_port").innerHTML = '31212';
        document.getElementById("client_loc0").innerHTML = document.getElementById("client_loc0").innerHTML.replace("35555","31212");
        
        document.getElementById("fc_server_port").value = '51212';
        document.getElementById("fc_server_port_h").value = '31212';
        document.getElementById("fc_client_loc").value = document.getElementById("fc_client_loc").value.replace("35555","31212");
        
        dE('client_type',0);
        
    }else{
        document.getElementById("default_server_port").innerHTML = '51127';
        document.getElementById("default_http_port").innerHTML = '35555';
        document.getElementById("client_loc0").innerHTML = document.getElementById("client_loc0").innerHTML.replace("31212","35555");
        
        document.getElementById("fc_server_port").value = '51127';
        document.getElementById("fc_server_port_h").value = '35555';
        document.getElementById("fc_client_loc").value = document.getElementById("fc_client_loc").value.replace("31212","35555");
        
        dE('client_type',1);
    }
}
      
function changeserver(id){
	if (id == 0){
		if (document.getElementById("server_loc").value == 0){
			dE('chat_port',0);
			dE('chat_host',0);
			dE('http_port',0);
		}else{
			dE('chat_port',1);
			dE('chat_host',1);
			dE('http_port',1);
		}
		dE('login_chat',1);
		dE('client_location',1);
		dE('client_loc0',1);
		dE('client_loc1',0);                
		dE('room_name',0);
		dE('u_al',1);
		dE('u_as',1);
        dE('set_skin',0);
        dE('set_lang',0);
        dE('room_list',1);
        dE('servertype',1);
		setclienttype();
	}else if (id == 1){
		dE('chat_port',0);
		dE('chat_host',0);
		dE('http_port',0);
		dE('login_chat',1);
		dE('client_location',1);                
		dE('client_loc0',0);
        dE('client_loc1',1);                
		dE('room_name',0);
		dE('u_al',1);
		dE('u_as',1);
		dE('set_skin',0);
		dE('set_lang',0);
		dE('room_list',1);
		dE('servertype',0);
		dE('client_type',1);
              
	}else{
		dE('chat_port',0);
		dE('chat_host',0);
		dE('http_port',0);
		dE('client_location',0);
		dE('room_name',1);
		dE('login_chat',0);
		dE('u_al',0);
		dE('u_as',0);
		dE('set_skin',1);
		dE('set_lang',1);
		dE('room_list',0);
		dE('servertype',0);
        dE('client_type',0);
	}
}
</script>
<?php 
			$page->output_nav_tabs($tabs, 'settings');
			$form = new Form("index.php?module=forum-chat", "post");		
			$table = new Table;
			
			$table->construct_cell('Chat Server Mode', array('style'=>'width:200px; text-align:right;','rowspan'=>'3'));
			$table->construct_cell(str_replace('type="radio"', 'type="radio" onclick="changeserver(0);"', $form->generate_radio_button('extendserver', 0, 'Chat Server Host By Your Own', (($chatSettings['fc_extendserver'] == '0') ? array('id'=>'extendserver0" checked="checked', 'checked'=>'checked') : array('id'=>'extendserver0')))) . 
				'<p style="padding:0 5px 5px 20px; font-family: verdana,sans-serif;font-size: 0.85em;font-style: italic;">
				Please download and install 123FlashChat first: <a target="_blank" href="http://www.123flashchat.com/download.html"> http://www.123flashchat.com/download.html</a>, 
				<br>and set Chat Client Location to: http://&lt;your chat server domain or ip&gt;:35555/</p>');
			$table->construct_row();
			$table->construct_cell(str_replace('type="radio"', 'type="radio" onclick="changeserver(1);"', $form->generate_radio_button('extendserver', 1, 'Chat Server Host By 123 Flash Chat', (($chatSettings['fc_extendserver'] == '1') ? array('id'=>'extendserver1" checked="checked', 'checked'=>'checked') : array('id'=>'extendserver1')))) . 
				'<p style="padding:0 5px 5px 20px; font-family: verdana,sans-serif;font-size: 0.85em;font-style: italic;">
				<a target="_blank" href="http://www.123flashchat.com/host.html">For paid host</a>, please set the Chat Client Location like this, for example: http://host71200.123flashchat.com/wordpress/, <a target="_blank" href="http://www.123flashchat.com/host.html">Buy host</a><br>
				<a target="_blank" href="http://www.123flashchat.com/host/apply.php">For trial host</a>, please setup Chat Client Location like this: http://trial.123flashchat.com/yourhostname/<br>
				Just replace "yourhostname" to the real one when you applied, <a target="_blank" href="http://www.123flashchat.com/host/apply.php">Apply trial host</a></p>');
			$table->construct_row();
			$table->construct_cell(str_replace('type="radio"', 'type="radio" onclick="changeserver(2);"', $form->generate_radio_button('extendserver', 2, 'Chat Server Host By 123 Flash Chat For Free', (($chatSettings['fc_extendserver'] == '2') ? array('id'=>'extendserver2" checked="checked', 'checked'=>'checked') : array('id'=>'extendserver2')))) . 
				'<p style="padding:0 5px 5px 20px; font-family: verdana,sans-serif;font-size: 0.85em;font-style: italic;">This chat server mode aims at testing the basic functions, only supported 1 room, no video chat function, and also you don\'t have the administrator permission of entering this chat room, you can select the mode 1 or 2 to get the full functions and control your chat room.</p>' );
			$table->construct_row();
			
			//login chat
			$table->construct_cell('Integration URL', array('style'=>'text-align:right;'));
			$table->construct_cell('To integrate users for auto-login to chat, please open the Chat Admin Panel,
				then System Settings &gt; Integration Panel, set authentication URL to: <br />
				<span style="color:#ff0000">'.$mybb->settings['bburl'].'/index.php?mod=123flashchat&act=loginchat&username=%username%&password=%password%</span><br />
				Then restart your chat server : Server Management &gt; Restart &gt; click Restart Server');
			$table->construct_row(($chatSettings['fc_extendserver'] == '2' ? array('class'=>'hidden', 'id'=>'login_chat') : array('id'=>'login_chat')));
			
			//server type
			$table->construct_cell('Chat Server Type', array('style'=>'text-align:right;'));
			$table->construct_cell(str_replace('type="radio"', 'type="radio" onclick="chooseservertype(0);"', $form->generate_radio_button('servertype', 0, '123FlashChat', ($chatSettings['fc_servertype'] != '1' ? array('id'=>'servertype0" checked="checked', 'checked'=>'checked') : array('id'=>'servertype0')))) .
				str_replace('type="radio"', 'type="radio" onclick="chooseservertype(1);"', $form->generate_radio_button('servertype', 1, '123PPVSoftware', ($chatSettings['fc_servertype'] == '1' ? array('id'=>'servertype1" checked="checked', 'checked'=>'checked') : array('id'=>'servertype1')))) );
			$table->construct_row(($chatSettings['fc_extendserver'] != '0' ? array('class'=>'hidden', 'id'=>'servertype') : array('id'=>'servertype')));
			
			//chat host, port, http port
			$table->construct_cell('Chat Server Host', array('style'=>'text-align:right;'));
			$table->construct_cell($form->generate_text_box('server_host', $chatSettings['fc_server_host'], array('id'=>'server_host_detail')) . 'Default:' . $_SERVER['SERVER_NAME']);
			$table->construct_row((($chatSettings['fc_extendserver'] != '0' || !$valid) ? array('class'=>'hidden', 'id'=>'chat_host') : array('id'=>'chat_host')));
			
			$table->construct_cell('Chat Server Port', array('style'=>'text-align:right;'));
			$table->construct_cell($form->generate_text_box('server_port', $chatSettings['fc_server_port'], array('id'=>'fc_server_port')) . 'Default:<span id="default_server_port">'.($chatSettings['fc_servertype'] == '0' ? 51127 : 51212) . '</span>');
			$table->construct_row((($chatSettings['fc_extendserver'] != '0' || !$valid) ? array('class'=>'hidden', 'id'=>'chat_port') : array('id'=>'chat_port')));
			
			$table->construct_cell('Chat Http Port', array('style'=>'text-align:right;'));
			$table->construct_cell($form->generate_text_box('server_port_h', $chatSettings['fc_server_port_h'], array('id'=>'fc_server_port_h')) . 'Default:<span id="default_http_port">'.($chatSettings['fc_servertype'] == '0' ? 35555 : 31212) . '</span>');
			$table->construct_row((($chatSettings['fc_extendserver'] != '0' || !$valid) ? array('class'=>'hidden', 'id'=>'http_port') : array('id'=>'http_port')));
			
			//client location
			$table->construct_cell('Chat Client Location', array('style'=>'text-align:right;'));
			$table->construct_cell($form->generate_text_box('client_loc', $chatSettings['fc_client_loc'], array('id'=>'fc_client_loc')) . '<span id="client_loc0" '.($chatSettings['fc_extendserver'] != '0' ? 'class="hidden"': 'class=""') . '>
				Example: http://'. $_SERVER['SERVER_NAME'].':'. ($chatSettings['fc_servertype'] == '0' ? 35555 : 31212) .'/</span>
            	<span id="client_loc1" '. ($fc_settings->fc_extendserver != '1' ? 'class="hidden"': 'class=""') .'>Example: http://hostxxx.123flashchat.com/group_name/</span>');
			$table->construct_row(($chatSettings['fc_extendserver'] == '2' ? array('class'=>'hidden', 'id'=>'client_location') : array('id'=>'client_location')));
			
			//client type
			$table->construct_cell('Chat Client Type', array('style'=>'text-align:right;'));
			$table->construct_cell($form->generate_radio_button('clienttype', 0, 'Html Chat', ($chatSettings['fc_clienttype'] != '1') ? array('id'=>'fc_clienttype0" checked="checked', 'checked'=>'checked') : array('id'=>'fc_clienttype0')) .
				$form->generate_radio_button('clienttype', 1, 'Flash Chat', ($chatSettings['fc_clienttype'] == '1') ? array('id'=>'fc_clienttype1" checked="checked', 'checked'=>'checked') : array('id'=>'fc_clienttype1')) );
			$table->construct_row(($chatSettings['fc_extendserver'] == '2' || ($chatSettings['fc_extendserver']=='0' && $chatSettings['fc_servertype'] == '1')) ? array('class'=>'hidden', 'id'=>'client_type') : array('id'=>'client_type'));
			
			//room name
			$table->construct_cell('Room Name', array('style'=>'text-align:right;'));
			$table->construct_cell($form->generate_text_box('room', $chatSettings['fc_room'], array()));
			$table->construct_row(($chatSettings['fc_extendserver'] != '2') ? array('class'=>'hidden', 'id'=>'room_name') : array('id'=>'room_name'));
			
			//room list
			$table->construct_cell('Show Room List', array('style'=>'text-align:right;'));
			$table->construct_cell($form->generate_radio_button('room_list', 0, 'No', ($chatSettings['fc_room_list'] != '1') ? array('id'=>'room_list_detail0" checked="checked', 'checked'=>'checked') : array('id'=>'room_list_detail0')) .
				$form->generate_radio_button('room_list', 1, 'Yes', ($chatSettings['fc_room_list'] == '1') ? array('id'=>'room_list_detail1" checked="checked', 'checked'=>'checked') : array('id'=>'room_list_detail1')) );
			$table->construct_row(($chatSettings['fc_extendserver'] == '2') ? array('class'=>'hidden', 'id'=>'room_list') : array('id'=>'room_list'));
			
			//user list
			$table->construct_cell('Show User List', array('style'=>'text-align:right;'));
			$table->construct_cell($form->generate_radio_button('user_list', 0, 'No', (($chatSettings['fc_user_list'] != '1') ? array('id'=>'user_list_detail0" checked="checked', 'checked'=>'checked') : array('id'=>'user_list_detail0'))) .
				$form->generate_radio_button('user_list', 1, 'Yes', (($chatSettings['fc_user_list'] == '1') ? array('id'=>'user_list_detail1" checked="checked', 'checked'=>'checked') : array('id'=>'user_list_detail1'))) );
			$table->construct_row(array('id'=>'room_list'));
			
			//client size
			$table->construct_cell('Chat Client Size', array('style'=>'text-align:right;'));
			$table->construct_cell(str_replace('type="radio"', 'type="radio" onclick="showchatsize(0);"', $form->generate_radio_button('fullscreen', 1, 'Full Screen', (($chatSettings['fc_fullscreen'] == '1') ? array('id'=>'chatsize_detail1" checked="checked', 'checked'=>'checked') : array('id'=>'chatsize_detail1')))) .
				str_replace('type="radio"', 'type="radio" onclick="showchatsize(1);"', $form->generate_radio_button('fullscreen', 0, 'Custom', (($chatSettings['fc_fullscreen'] != '1') ? array('id'=>'chatsize_detail0" checked="checked', 'checked'=>'checked') : array('id'=>'chatsize_detail0')))) .
				'<span id="chatsize"'. (($chatSettings['fc_fullscreen'] == '1') ? 'class="hidden"': 'class=""').'> 
					width : <input class="chatsize" name="client_width" id="client_width" value="'. $chatSettings['fc_client_width'].'" />
					height : <input class="chatsize" name="client_height" id="client_height" value="'. $chatSettings['fc_client_height'].'" />
				</span>');
			$table->construct_row();
			
			//client language
			$langlist = array('auto'=>'Auto detect', 'en'=>'English', 'zh-CN'=>'GB Chinese', 'zh-TW'=>'Big5 Chinese', 'fr'=>'French', 'it'=>'Italian', 'de'=>'German', 'nl'=>'Dutch', 'hu'=>'Hungarian', 'es'=>'Spanish', 'hr'=>'Croatian', 'tr'=>'Turkish','ar'=>'Arabic', 'pt'=>'Portuguese', 'ru'=>'Russian', 'ko'=>'Korean', 'serbian'=>'Serbian', 'no'=>'Norwegian', 'ja'=>'Japanese');
			$table->construct_cell('Chat Client Language', array('style'=>'text-align:right;'));
			$table->construct_cell('<div id="u_al" '.(($chatSettings['fc_extendserver'] == '2') ? 'class="hidden"': 'class=""') . '> Note: You can set the language in 123FlashChat Admin Panel -> Client Settings -> Languages </div>
				<div id="set_lang" '. ($chatSettings['fc_extendserver'] != '2' ? 'class="hidden"': 'class=""') . ' >' . 
					$form->generate_select_box('client_lang', $langlist, $chatSettings['fc_client_lang'])
				. '</div>');
			$table->construct_row();
			
			//client skin
			$skinlist = array('default'=>'Default', 'green'=>'Green', 'orange'=>'Orange', 'red'=>'Red', 'black'=>'Black', 'beige'=>'Beige', 'standard'=>'Standard', 'clean'=>'Clean', 'artistic'=>'Artistic');
			$table->construct_cell('Chat Client Skin', array('style'=>'text-align:right;'));
			$table->construct_cell('<div id="u_as" '.(($chatSettings['fc_extendserver'] == '2') ? 'class="hidden"': 'class=""') . '> Note: You can set the skin in 123FlashChat Admin Panel -> Client Settings -> Skin</div>
				<div id="set_skin" '. ($chatSettings['fc_extendserver'] != '2' ? 'class="hidden"': 'class=""') . ' >' . 
					$form->generate_select_box('client_skin', $skinlist, $chatSettings['fc_client_skin'])
				. '</div>');
			$table->construct_row();
			
			$table->output('Chat Setting');			
			echo $form->generate_hidden_field('server_loc', $valid, array('id'=>'server_loc'));			
			$buttons[] = $form->generate_submit_button('Save Settings', array());			
			$form->output_submit_wrapper($buttons);			
			$form->end();
			
		}
		$page->output_footer();
		
	}		
	exit;
}

function chat_chatpage($page){
	$chatSetting = chat_getChatSetting();
	if($chatSetting['fc_extendserver'] == '2'){
		$clientType = 'free';
	}else{
		if(($chatSetting['fc_extendserver'] == 0 && $chatSetting['fc_servertype'] != 1 && $chatSetting['fc_clienttype'] == 1) 
			|| ($chatSetting['fc_extendserver'] == 1 && $chatSetting['fc_clienttype'] == 1)){
			$clientType = 'flash';
		}else{
			$clientType = 'html';
		}
	}
	$chaturl = chat_getChatUrl($chatSetting,false);
	if($chatSetting['fc_fullscreen'] == '1'){
		$page = '<!DOCTYPE html>
<head>
	<meta charset="UTF-8" />
	<title>123 Flash Chat</title>
	<style>
		html,body{
			height:100%;
		}
		body{
			margin:0px; overflow:hidden;padding:0px;
		}
	</style>	
</head>
<body>
</body>
<html>';
		$chatSetting['fc_client_width'] = '100%';
		$chatSetting['fc_client_height'] = '100%';
	}
	
	if($clientType == 'free'){
		if($chatSetting['fc_fullscreen'] == '1'){
			$chat = '<script language="javascript">';
			$chat .= 'var clientWidth = document.body.clientWidth;';
			$chat .= 'var clientHeight = window.innerHeight;';			
			$chat .= 'var htmlcode = \'<script language="javascript" src="'.$chaturl.'&width=\' + clientWidth;';
			$chat .= 'htmlcode += \'&height=\' + clientHeight + \'"></sc\';';
			$chat .= 'htmlcode += \'ript>\';';
			$chat .= 'document.write(htmlcode);';
			$chat .= '</script>';
		}else{
			$chat = '<script language="javascript" src="'.$chaturl.'&width='.$chatSetting['fc_client_width'].'&height='.$chatSetting['fc_client_height'].'">';
			$chat .= '<script>';
			$chat .= 'document.getElementById("123flashchat").style.margin = "0 auto";';
			$chat .= '</script>';
		}
	} elseif ($clientType == 'html'){
		$chat = '<script src="'. $chatSetting['fc_client_loc'] .'123flashchat.js"></script>';
		$chat .= '<iframe width="'.$chatSetting['fc_client_width'].'" height="'.$chatSetting['fc_client_height'].'" src="'.$chaturl.'" vspale="0" scrolling="no" noresize="noresize" name="htmlchat" marginwidth="0" marginheight="0" framespacing="0" frameborder="0" border="0"></iframe>';
		
	} else{
		$chat =  '<script src="'. $chatSetting['fc_client_loc'] .'123flashchat.js"></script>
			<object width="'.$chatSetting['fc_client_width'].'" height="'.$chatSetting['fc_client_height'].'" classid="clsid:D27CDB6E-AE6D-11cf-96B8-444553540000" codebase="http://download.macromedia.com/pub/shockwave/cabs/flash/swflash.cab#version=6,0,19,0" id="topcmm_123flashchat" type="application/x-shockwave-flash">
			<param name=movie value="'.$chaturl.'">
			<param name=quality value="high">
			<param name="menu" value="false">
			<param name="allowScriptAccess" value="always">
			<embed src="'.$chaturl.'" width="'.$chatSetting['fc_client_width'].'" height="'.$chatSetting['fc_client_height'].'" allowScriptAccess="always" quality="high" menu="false" type="application/x-shockwave-flash" pluginspace="http://www.macromedia.com/go/getflashplayer"  name="topcmm_123flashchat"></embed>
		</object>';
	}
	if($chatSetting['fc_fullscreen'] == '1'){
		$page = str_replace('<body>', '<body>' . $chat, $page);
	}else{
		$page = str_replace('<div id="content">', '<div id="content"><div style="width:'.($chatSetting['fc_client_width'] + 10).'px; margin:0 auto; >' . $chat . '</div>', $page);
	}	
	return $page;
}


function chat_saveConfig($data){
	global $db;
	foreach ($data as $key => $value){
		$chatsetting['fc_'.$key] = $value;
	}
	$db->update_query('123flashchat', $chatsetting, 'id=1');
	flash_message('Save Success', 'success');
	admin_redirect("index.php?module=forum-chat");
}

function chat_getServerHostPortHost($client_location){
	$content = topcmmRequestRemote::requestRemote($client_location,1);
	if ($content){
		//server port
		preg_match('/init_port=([0-9]*)/', $content, $matches);
        if(isset($matches[1])){
        	$data['fc_server_port'] = $matches[1];			        	
        }
        //server port s
		preg_match('/init_port_s=([0-9]*)/', $content, $matches);
        if(isset($matches[1])){
        	$data['fc_server_port_s'] = $matches[1];			        	
        }
        //server port h
		preg_match('/init_port_h=([0-9]*)/', $content, $matches);
        if(isset($matches[1])){
        	$data['fc_server_port_h'] = $matches[1];			        	
        }
        //server host
		preg_match('/init_host=([a-zA-Z0-9.]*)/', $content, $matches);
        if(isset($matches[1])){
        	$data['fc_server_host'] = $matches[1];			        	
        }
        //server host s
		preg_match('/init_host_s=([a-zA-Z0-9.]*)&/', $content, $matches);
        if(isset($matches[1])){
        	$data['fc_server_host_s'] = $matches[1];			        	
        }
        //server host h
		preg_match('/init_host_h=([a-zA-Z0-9.]*)&/', $content, $matches);
        if(isset($matches[1])){
        	$data['fc_server_host_h'] = $matches[1];			        	
        }
        return $data;
    }else{
    	return false;
    }
}

function chat_getServerHostPortLocal($client_location){
	$content = topcmmRequestRemote::requestRemote($client_location.'htmlchat/config/config.js',1);
	if ($content){
		//server host
	 	preg_match('/init_host = "([a-zA-Z0-9.]*)";/', $content, $matches);
        if(isset($matches[1])){
        	$data['fc_server_host'] = $matches[1];			        	
        }else{
	        preg_match('/init_host="([a-zA-Z0-9.]*)";/', $content, $matches);
	        if(isset($matches[1])){
	        	$data['fc_server_host'] = $matches[1];			        	
	        }else{
	        	$data['fc_server_host'] = '';
	        }
        }
        //server port
        preg_match('/init_port = ([0-9]*);/', $content, $matches);
        if(isset($matches[1])){
        	$data['fc_server_port'] = $matches[1];			        	
        }else{
        	$data['fc_server_port'] = '';
        }
        //server host s
		preg_match('/init_host_s = "([a-zA-Z0-9.]*)";/', $content, $matches);
        if(isset($matches[1])){
        	$data['fc_server_host_s'] = $matches[1];			        	
        }else{
	        preg_match('/init_host_s="([a-zA-Z0-9.]*)";/', $content, $matches);
	        if(isset($matches[1])){
	        	$data['fc_server_host_s'] = $matches[1];			        	
	        }else{
	        	$data['fc_server_host_s'] = '';
	        }
        }
        //server port s
        preg_match('/init_port_s = ([0-9]*);/', $content, $matches);
        if(isset($matches[1])){
        	$data['fc_server_port_s'] = $matches[1];			        	
        }else{
        	$data['fc_server_port_s'] = '';
        }
        //server host h
		preg_match('/init_host_h = "([a-zA-Z0-9.]*)";/', $content, $matches);
        if(isset($matches[1])){
        	$data['fc_server_host_h'] = $matches[1];			        	
        }else{
	        preg_match('/init_host_h="([a-zA-Z0-9.]*)";/', $content, $matches);
	        if(isset($matches[1])){
	        	$data['fc_server_host_h'] = $matches[1];			        	
	        }else{
	        	$data['fc_server_host_h'] = '';
	        }
        }
        //server port h
        preg_match('/init_port_h = ([0-9]*);/', $content, $matches);
        if(isset($matches[1])){
        	$data['fc_server_port_h'] = $matches[1];			        	
        }else{
        	$data['fc_server_port_h'] = '';
        }
        return $data;
    }else{
    	return false;
    }
}

function chat_getChatSetting(){
	global $db;
	$query = $db->simple_select("123flashchat", "*", "id=1", 1);
	$chatSettings = $db->fetch_array($query);
	return $chatSettings;
}

function chat_getUserInfoByIdKey($uid, $loginkey){
	global $db;
	$query = $db->simple_select("users", "*", "uid=".$uid, 1);
	$userinfo = $db->fetch_array($query);
	return $userinfo;
}

function chat_getUserInfoByName($username){
	global $db;
	$query = $db->simple_select("users", "*", "username='".$username."'", 1);
	$userinfo = $db->fetch_array($query);
	return $userinfo;
}

function chat_getValid($fcSetting){
	$c_server_loc = 1;
	if($fcSetting['fc_server_host']){
		if($fcSetting['fc_server_host'] == $_SERVER['SERVER_NAME']){
			$c_own_loc = validate_client('http://'.$fcSetting['fc_server_host'].':'.$fcSetting['fc_server_port_h'].'/');
			if(!$c_own_loc){
				$c_server_loc = 0;
			}
		}
	}else{
		$c_own_loc = validate_client('http://'.$_SERVER['SERVER_NAME'].':'.$fcSetting['fc_server_port_h'].'/');
		if(!$c_own_loc){
			$c_server_loc = 0;
		}
	}
	return $c_server_loc;
}

function validate_client($client_loc){
	$c_own_loc = 1;
	$swf = $client_loc . 'admin_123flashchat.swf';
    if($headers = topcmmRequestRemote::requestRemote($swf,0)){
        $c_own_loc = (substr($headers, 9, 3) == '200') ? 0 : 1;
	}
        return $c_own_loc;
}

function validate_data_api($data_api){
	$da = 1;
	if(substr(topcmmRequestRemote::requestRemote($data_api,0), 9, 3) == 200){
		$da = 0;
	}
	return $da;
}

function chat_getChatUrl($chatSettings, $adminpanel = FALSE){
	$clientname = '';
	$url = '';
	if($chatSettings['fc_extendserver'] == 2){
		if($chatSettings['fc_room'] == ''){
			$chatSettings['fc_room'] = 'Lobby';
		}
		$url = 'http://free.123flashchat.com/js.php?room=' . urlencode($chatSettings['fc_room']) . '&skin=' . $chatSettings['fc_client_skin'] . '&lang=' . $chatSettings['fc_client_lang'];
	}else{
		if($adminpanel){
			$clientname = 'admin_123flashchat.swf';
		}else{
			if(($chatSettings['fc_extendserver'] == 0 && $chatSettings['fc_servertype'] != 1 && $chatSettings['fc_clienttype'] == 1) 
				|| ($chatSettings['fc_extendserver'] == 1 && $chatSettings['fc_clienttype'] == 1)){
				$clientname = '123flashchat.swf';
			}else{
				$clientname = 'htmlchat/123flashchat.html';
			}
		}
		$url = $chatSettings['fc_client_loc'] . $clientname . '?init_host=' . $chatSettings['fc_server_host'] . '&init_port=' . $chatSettings['fc_server_port'];
		$url .= ($chatSettings['fc_server_host_s'] ? '&init_host_s='.$chatSettings['fc_server_host_s'] : '') . ($chatSettings['fc_server_port_s'] ? '&init_port_s='.$chatSettings['fc_server_port_s'] : '');
		$url .= ($chatSettings['fc_server_host_h'] ? '&init_host_h='.$chatSettings['fc_server_host_h'] : '') . ($chatSettings['fc_server_port_h'] ? '&init_port_h='.$chatSettings['fc_server_port_h'] : '');
		if($chatSettings['fc_extendserver'] == 1){
			$url .= '&init_group=' . $chatSettings['fc_group'];
		}
	}
	if(!empty($_COOKIE['mybbuser'])){
		$cookieData = explode('_', $_COOKIE['mybbuser']);
		if(is_numeric($cookieData[0])){
			$userinfo = chat_getUserInfoByIdKey($cookieData[0], $cookieData[1]);
			if(is_array($userinfo)){
				$url .= '&init_user=' . $userinfo['username'];
				if($chatSettings['fc_extendserver'] != 2){
					$url .= '&init_password=' . $userinfo['password'];
				}
			}
		}
	}
	if (!empty($_GET['room'])){
		$url .= "&init_room=" . $_GET['room'];
	}
	return $url;
}

function chat_status($page){
	$page = str_replace('<div class="bottommenu">', '<table border="0" cellspacing="0" cellpadding="4" width="100%" bgcolor="#f5f5f5" style="border: 1px solid #0F5C8E;">
	<tbody><tr>
		<td class="thead" width="100%" colspan="2">
			<div class="float_right">
				<strong><a href="http://www.123flashchat.com" onclick="window.open(\'index.php?mod=123flashchat&act=chat\');return false;">Chat Now</a></strong>
			</div>
			<div><strong>Chat Status</strong></div>
		</td>
	</tr>'.serviceGetChatStats().'</tbody>
</table><br /><div class="bottommenu">', $page);
	return $page;
}

function serviceGetChatStats(){
    $sOutputCode = '';    
    $fc_config = chat_getChatSetting();
    
    $status = chat_getStatus($fc_config);
    $sConnectionInfo = '<tr bgcolor="#ADCBE7">
		<td class="tcat" width="100%">'.
			(!empty($status['rn']) ? '<b>'.$status['rn'].'</b> rooms, ' : '').
			($status['rn'] ? '<b>'.$status['cn'].'</b>' : '<b>0</b>' ). ' connections, '.
			($status['ln'] ? '<b>'.$status['ln'].'</b>' : '<b>0</b>' ). ' login users.'
		.'<td>
	</tr>';
    
    if ($fc_config['fc_user_list']){
        $users  = chat_getUsers($fc_config);
    }
    if (($fc_config['fc_room_list']) && ($fc_config['fc_extendserver'] != "2")){
        $rooms  = chat_getRooms($fc_config);
    }
    if(isset($rooms)){
    	$sOutputCode .= "<p><b>Rooms:</b> ";
        if(!$rooms){
            $sOutputCode .= "None";
        }else{
            $xa = '';
            foreach($rooms as $room){
				$sOutputCode .= $xa . '<a href="index.php?mod=123flashchat&act=chat&room=' . $room['id'].'" target="_blank" >' .$room['name'] .'</a>(' . $room['count'] . ')';
                $xa = ', ';
            }
        }
        $sOutputCode .= "</p>";
    }
    if(isset($users)){
        $sOutputCode .= "<p><b>Users:</b> ";
        if(!$users){
            $sOutputCode .= "None";
        }else{
            $xb = '';
            foreach($users as $user){
                $sOutputCode .= $xb . $user['name'];
                $xb = ', ';
            }
        }
		$sOutputCode .= "</p>";
    }
	//$thishref = CHAT_PLUGIN_URL.'/123flashchat.php?room=';
    //$js = ' onclick="window.open(\''.$thishref.'\');return false;"';
	//$sOutputCode .=  '<p><a href="http://www.123flashchat.com"' .$js.">" ."<b>Chat Now!</b>" ."</a></p>";
    $sOutputCode = $sConnectionInfo . '<tr bgcolor="#f5f5f5">
		<td class="trow1" width="100%">'.
			 $sOutputCode
		.'</td>
	</tr>';
    return $sOutputCode;
}

function chat_getStatus($fc_config){
	$data = topcmmRequestRemote::requestRemote(CACHE_PATH . "status.js",1);
    $status_json = substr($data,10);
    if ((time() > substr($data,0,10)) || !$status_json){
        $server =  $fc_config['fc_extendserver'];
        switch ($server){
            case "0":
                $status_js = $fc_config['fc_api_url'] . "online.js";
                if($rs = topcmmRequestRemote::requestRemote($status_js,1)){
                    $status_json = substr($rs,11,-1);
                }
                break;
            case "1":
                $status_js = $fc_config['fc_api_url'] . "online.js?group=" .$fc_config['fc_group'];
                if($rs = topcmmRequestRemote::requestRemote($status_js,1)){
                    $status_json = substr($rs,11,-1);
                }
                break;
            case "2":
                $status_js = "http://free.123flashchat.com/freeroomnum.php?roomname=" . $fc_config['fc_room'];
                if($rs = topcmmRequestRemote::requestRemote($status_js,1)){
                    preg_match("/document.write\('(.*)'\);/",$rs,$matches);
                    $status['ln'] = $matches[1];
                    $status_json = json_encode($status);
                }
                break;
        }
        @file_put_contents(CACHE_PATH . "status.js",(time() + 120) . $status_json);
    }
    return json_decode($status_json,true);
}

function chat_getRooms($fc_config){
    $data = topcmmRequestRemote::requestRemote(CACHE_PATH ."rooms.js", 1);
    $rooms_json = substr($data,10);
    //var_dump($data);
    if ((time() > substr($data,0,10)) || !$rooms_json){
        $server = $fc_config['fc_extendserver'];
		switch ($server){
            case "0":
                $room_js = $fc_config['fc_api_url'] . "rooms.js";
                break;
            case "1":
                $room_js = $fc_config['fc_api_url'] . "rooms.js?group=" . $fc_config['fc_group'];
                break;
        }
        if($rs = topcmmRequestRemote::requestRemote($room_js,1)){
            $rooms_json = substr($rs,10,-1);
        }
        @file_put_contents(CACHE_PATH ."rooms.js",(time() + 120) . $rooms_json);
    }
    return json_decode($rooms_json, true);
}

function chat_getUsers($fc_config){
	// Timeout in seconds
    $context = stream_context_create(array('http' => array('timeout' => 3)));
    $data =  topcmmRequestRemote::requestRemote(CACHE_PATH ."users.js",1);
    $users_json = substr($data,10);
    if ((time() > substr($data,0,10)) || !$users_json){
        $server =  $fc_config['fc_extendserver'];
        switch ($server){
            case "0":
                $rooms = chat_getRooms($fc_config);
                $users = array();
                if($rooms){
	                foreach ($rooms as $room){
	                    $user_js = $fc_config['fc_api_url'] . "roomonlineusers.js?roomid=" . $room['id'];
	                    if($rs = topcmmRequestRemote::requestRemote($user_js,1)){
	                        $users = array_merge($users, json_decode(substr($rs,20,-1),true));
	                    }
	                }
                }
                $users_json = json_encode($users);
                break;
            case "1":
                $user_js = $fc_config['fc_api_url'] . "roomonlineusers.js?group=" . $fc_config['fc_group'];
                if($rs = topcmmRequestRemote::requestRemote($user_js,1)){
                    $users_json = substr($rs,20,-1);
                }
                break;
            case "2":
                $user_js = "http://free.123flashchat.com/freeroomuser.php?roomname=" . $fc_config['fc_room'];
                if($rs = topcmmRequestRemote::requestRemote($user_js,1)){
                    preg_match("/document.write\('(.*)'\);/",$rs,$matches);
                    foreach (explode(',', $matches[1]) as $user){
                        $users[] = array('name' => $user);
                    }
                }
                $users_json = json_encode($users);
                break;
        }
		$users_json = chat_filterUserList($users_json);
        @file_put_contents(CACHE_PATH ."users.js",(time() + 120) . $users_json);
    }
    return json_decode($users_json, true);
}

function chat_filterUserList($users_json){
	$user_array =  json_decode($users_json,true);
	$user_regroup_array = array();
	$user_tmp_array = array();
	foreach($user_array as $key => $val){
		if (!in_array($val['name'], $user_tmp_array)){
			$user_tmp_array[] = $val['name'];
			$user_regroup_array[$key] = $user_array[$key];
		}
	}
	return json_encode($user_regroup_array);
}

class topcmmRequestRemote{
    static  $timeout = 3;
    static function requestRemote($url,$mode=1){
        /*
         * get Info Mode :
         *          1: body;
         *          0: header;
        */
        if(!empty($url)){
            if(function_exists("curl_init")){
                return self::curlRequestRemote($url,$mode);
            } else if(ini_get("allow_url_fopen")) {
                if($mode == "1") {
                    return self::filegetContentsRequestRemote($url);
                }else{
                    return self::fsockopenRequestRemote($url);
                }
            } else {
                return false;
            }
        } else {
            return false;
        }
    }

    static function curlRequestRemote($url,$mode){
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $url);
        curl_setopt($ch, CURLOPT_TIMEOUT, self::$timeout);
        @curl_setopt($ch, CURLOPT_USERAGENT, _USERAGENT_);
        @curl_setopt($ch, CURLOPT_REFERER,_REFERER_);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        if($mode == "0"){
            curl_setopt($ch, CURLOPT_HEADER, true);
        }
        $r = curl_exec($ch);
        curl_close($ch);
        if($mode == "0"){
            return substr($r,0,17);
        }
        return $r;
    }

    static function filegetContentsRequestRemote($url){
        $context = stream_context_create(array('http' => array(
            'timeout' => self::$timeout      // Timeout in seconds
        )));
        return @file_get_contents($url,0,$context);
    }

    static function fsockopenRequestRemote($url){
        $url = @parse_url($url);
        if($fp = @fsockopen($url['host'],empty($url['port'])?80:$url['port'],$errorno,$error,self::$timeout)){
            fputs($fp,"GET ".(empty($url['path'])?'/':$url['path'])." HTTP/1.1\r\n");
            fputs($fp,"Host:$url[host]\r\n\r\n");
            while(!feof($fp)){
                $tmp = fgets($fp);
                if(trim($tmp) == ''){
                    break;
                } else if(preg_match_all('|HTTP(.*)|U',$tmp,$arr)) {
                    return $tmp;
                }
            }
            return false;
        } else {
            return false;
        }
    }
}

?>